from Tkinter import *
from GridWindow import *

#####
# This class is used to create the controls for the Sudoku GUI. Note
# that this is the root class of this GUI. This means that if this
# window is closed, all the other windows are closed.
class SudokuGUI:
    
    # Initializes the GUI interface
    def __init__(self, master):
    
        self.master = master
        self.master.protocol("WM_DELETE_WINDOW", self.onQuit)
    
        frame = Frame(master)

        topFrame = Frame(frame, borderwidth=5)
        self.btn_open = Button(topFrame, width=15, text="Open Main Board", command=self.open_main_board)
        self.btn_open.pack()
        self.btn_undo = Button(topFrame, width=15, text="Undo last", command=self.undo)
        self.btn_undo.pack()
        self.btn_undo_since_error = Button(topFrame, width=15, text="Undo since error", command=self.undo_last_error)
        self.btn_undo_since_error.pack()
        topFrame.pack()
        
        blockFrame = Frame(frame, borderwidth=5)
        
        frame_label = Frame(blockFrame)
        label = Label(frame_label, text="Open Block Windows")
        label.pack()
        frame_label.pack()
        
        frame_buttons = Frame(blockFrame)
        self.btn_open_block1 = Button(frame_buttons, text=" 1 ", command= lambda : self.open_block_board(1) )
        self.btn_open_block1.grid(row=0, column=0)
        self.btn_open_block2 = Button(frame_buttons, text=" 2 ", command= lambda : self.open_block_board(2) )
        self.btn_open_block2.grid(row=0, column=1)
        self.btn_open_block3 = Button(frame_buttons, text=" 3 ", command= lambda : self.open_block_board(3) )
        self.btn_open_block3.grid(row=0, column=2)
        self.btn_open_block4 = Button(frame_buttons, text=" 4 ", command= lambda : self.open_block_board(4) )
        self.btn_open_block4.grid(row=1, column=0)
        self.btn_open_block5 = Button(frame_buttons, text=" 5 ", command= lambda : self.open_block_board(5) )
        self.btn_open_block5.grid(row=1, column=1)
        self.btn_open_block6 = Button(frame_buttons, text=" 6 ", command= lambda : self.open_block_board(6) )
        self.btn_open_block6.grid(row=1, column=2)
        self.btn_open_block7 = Button(frame_buttons, text=" 7 ", command= lambda : self.open_block_board(7) )
        self.btn_open_block7.grid(row=2, column=0)
        self.btn_open_block8 = Button(frame_buttons, text=" 8 ", command= lambda : self.open_block_board(8) )
        self.btn_open_block8.grid(row=2, column=1)
        self.btn_open_block9 = Button(frame_buttons, text=" 9 ", command= lambda : self.open_block_board(9) )
        self.btn_open_block9.grid(row=2, column=2)
        frame_buttons.pack()
        
        blockFrame.pack()
        
        rowFrame = Frame(frame, borderwidth=5)
        
        frame_label = Frame(rowFrame)
        label = Label(frame_label, text="Open Row Windows")
        label.pack()
        frame_label.pack()
        
        frame_buttons = Frame(rowFrame)
        self.btn_open_block1 = Button(frame_buttons, text=" 1 ", command= lambda : self.open_row_board(1) )
        self.btn_open_block1.grid(row=0, column=0)
        self.btn_open_block2 = Button(frame_buttons, text=" 2 ", command= lambda : self.open_row_board(2) )
        self.btn_open_block2.grid(row=0, column=1)
        self.btn_open_block3 = Button(frame_buttons, text=" 3 ", command= lambda : self.open_row_board(3) )
        self.btn_open_block3.grid(row=0, column=2)
        self.btn_open_block4 = Button(frame_buttons, text=" 4 ", command= lambda : self.open_row_board(4) )
        self.btn_open_block4.grid(row=1, column=0)
        self.btn_open_block5 = Button(frame_buttons, text=" 5 ", command= lambda : self.open_row_board(5) )
        self.btn_open_block5.grid(row=1, column=1)
        self.btn_open_block6 = Button(frame_buttons, text=" 6 ", command= lambda : self.open_row_board(6) )
        self.btn_open_block6.grid(row=1, column=2)
        self.btn_open_block7 = Button(frame_buttons, text=" 7 ", command= lambda : self.open_row_board(7) )
        self.btn_open_block7.grid(row=2, column=0)
        self.btn_open_block8 = Button(frame_buttons, text=" 8 ", command= lambda : self.open_row_board(8) )
        self.btn_open_block8.grid(row=2, column=1)
        self.btn_open_block9 = Button(frame_buttons, text=" 9 ", command= lambda : self.open_row_board(9) )
        self.btn_open_block9.grid(row=2, column=2)
        frame_buttons.pack()
        
        rowFrame.pack()
        
        colFrame = Frame(frame, borderwidth=5)
        
        frame_label = Frame(colFrame)
        label = Label(frame_label, text="Open Column Windows")
        label.pack()
        frame_label.pack()
        
        frame_buttons = Frame(colFrame)
        self.btn_open_block1 = Button(frame_buttons, text=" 1 ", command= lambda : self.open_col_board(1) )
        self.btn_open_block1.grid(row=0, column=0)
        self.btn_open_block2 = Button(frame_buttons, text=" 2 ", command= lambda : self.open_col_board(2) )
        self.btn_open_block2.grid(row=0, column=1)
        self.btn_open_block3 = Button(frame_buttons, text=" 3 ", command= lambda : self.open_col_board(3) )
        self.btn_open_block3.grid(row=0, column=2)
        self.btn_open_block4 = Button(frame_buttons, text=" 4 ", command= lambda : self.open_col_board(4) )
        self.btn_open_block4.grid(row=1, column=0)
        self.btn_open_block5 = Button(frame_buttons, text=" 5 ", command= lambda : self.open_col_board(5) )
        self.btn_open_block5.grid(row=1, column=1)
        self.btn_open_block6 = Button(frame_buttons, text=" 6 ", command= lambda : self.open_col_board(6) )
        self.btn_open_block6.grid(row=1, column=2)
        self.btn_open_block7 = Button(frame_buttons, text=" 7 ", command= lambda : self.open_col_board(7) )
        self.btn_open_block7.grid(row=2, column=0)
        self.btn_open_block8 = Button(frame_buttons, text=" 8 ", command= lambda : self.open_col_board(8) )
        self.btn_open_block8.grid(row=2, column=1)
        self.btn_open_block9 = Button(frame_buttons, text=" 9 ", command= lambda : self.open_col_board(9) )
        self.btn_open_block9.grid(row=2, column=2)
        frame_buttons.pack()
        
        colFrame.pack()
        
        bottomFrame = Frame(frame, borderwidth=5)
        self.btn_quit = Button(bottomFrame, text="Quit", command=self.quit)
        self.btn_quit.pack()
        bottomFrame.pack()
        
        frame.pack()
    
    # This function is called when the "Open Main Board" button is pressed.
    def open_main_board(self):
        #Put your code here
        MainWindow(self.master)

    # This function is called when one of the "Open Block Board" buttons is 
    # pressed. Note that the id parameter describes which button was pressed.
    def open_block_board(self, id):
        #Put your code here
        BlockWindow(self.master, id)

    # This function is called when one of the "Open Row Board" buttons is 
    # pressed. Note that the id parameter describes which button was pressed.
    def open_row_board(self, id):
        #Put your code here
        RowWindow(self.master, id)

    # This function is called when one of the "Open Column Board" buttons is 
    # pressed. Note that the id parameter describes which button was pressed.                
    def open_col_board(self, id):
        #Put your code here
        ColWindow(self.master, id)
                    
    # This function is called when the "Undo" button is pressed.
    def undo(self):
        #Put your code here
        print "Undoing"        
    
    # This function is called when the "Undo Last Error" button is pressed.
    def undo_last_error(self):
        #Put your code here
        print "Undoing since last error"
    
    # This function is called when the "Quit" button is pressed
    def quit(self):
        self.master.destroy()
        
    # This function is called when the window is closed.
    def onQuit(self):
        self.master.destroy()
        
root = Tk()
sudokuGui = SudokuGUI(root)

root.title('Ultimate Sudoku')
root.mainloop()
